package bench;

import java.util.Iterator;

import com.hp.hpl.jena.graph.Graph;
import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.graph.TripleMatch;
import com.hp.hpl.jena.graph.impl.GraphBase;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;
import com.hp.hpl.jena.util.iterator.NiceIterator;

import com.hp.hpl.jena.sparql.core.DatasetGraph;
import com.hp.hpl.jena.sparql.core.Quad;

import de.fuberlin.wiwiss.ng4j.NamedGraphSet;


public class DatasetGraphWrappingJenaGraph extends GraphBase
                                           implements Graph
{
	// members

	final public DatasetGraph dataset;


	// initialization

	public DatasetGraphWrappingJenaGraph ( DatasetGraph dataset )
	{
		this.dataset = dataset;
	}


	// implementation of the GraphBase abstract methods

	@Override
	protected ExtendedIterator<Triple> graphBaseFind ( TripleMatch m )
	{
		Iterator<Quad> it = dataset.find( null, m.getMatchSubject(), m.getMatchPredicate(), m.getMatchObject() );
		return new QuadsToTriplesIterator( it );
	}

	@Override
	public void performAdd ( Triple t )
	{
		throw new UnsupportedOperationException();
	}

	@Override
	public void performDelete ( Triple t )
	{
		throw new UnsupportedOperationException();
	}


	static class QuadsToTriplesIterator extends NiceIterator<Triple>
	{
		final protected Iterator<Quad> inputIterator;
		public QuadsToTriplesIterator ( Iterator<Quad> inputIterator ) { this.inputIterator = inputIterator; }

		@Override
		final public boolean hasNext () { return inputIterator.hasNext(); }

		@Override
		final public Triple next () { return inputIterator.next().asTriple(); }

		@Override
		final public void remove () { inputIterator.remove(); }
	}

}
