package bench;

import com.hp.hpl.jena.graph.Graph;
import com.hp.hpl.jena.graph.Node;

import de.fuberlin.wiwiss.ng4j.NamedGraphSet;

import de.fuberlin.wiwiss.jenaext.NodeDictionary;


public class IdBasedNamedGraphSetImpl extends de.fuberlin.wiwiss.ng4j.impl.idbased.IdBasedNamedGraphSetImpl
{
	// initialization

	public IdBasedNamedGraphSetImpl ( NodeDictionary nodeDict )
	{
		super( nodeDict );
	}


	// redefinitions of NamedGraphSetImpl methods

	@Override
	public Graph asJenaGraph ( Node defaultGraphForAdding )
	{
		if ( defaultGraphForAdding != null && ! containsGraph(defaultGraphForAdding) ) {
			createGraph( defaultGraphForAdding );
		}

		IdBasedUnionGraph unionGraph = new IdBasedUnionGraph( this );
		if ( defaultGraphForAdding != null ) {
			unionGraph.setBaseGraph( getGraph(defaultGraphForAdding) );
		}

		return unionGraph;
	}


	class IdBasedUnionGraph extends de.fuberlin.wiwiss.ng4j.impl.idbased.IdBasedUnionGraph
	{
		final public NamedGraphSet ngs;
		public IdBasedUnionGraph ( IdBasedNamedGraphSetImpl ngs ) {
			super( ngs.graphs, ngs.nodeDict );
			this.ngs = ngs;
		}
	}

}
