package bench;

import com.hp.hpl.jena.graph.Graph;
import com.hp.hpl.jena.graph.Node;

import de.fuberlin.wiwiss.ng4j.NamedGraphSet;


public class NamedGraphSetImpl extends de.fuberlin.wiwiss.ng4j.impl.NamedGraphSetImpl
{
	// redefinitions of NamedGraphSetImpl methods

	@Override
	public Graph asJenaGraph ( Node defaultGraphForAdding )
	{
		if ( defaultGraphForAdding != null && ! containsGraph(defaultGraphForAdding) ) {
			createGraph( defaultGraphForAdding );
		}

		UnionGraph unionGraph = new UnionGraph( this );
		if ( defaultGraphForAdding != null ) {
			unionGraph.setBaseGraph( getGraph(defaultGraphForAdding) );
		}

		return unionGraph;
	}


	class UnionGraph extends de.fuberlin.wiwiss.ng4j.impl.NamedGraphSetImpl.UnionGraph
	{
		final public NamedGraphSet ngs;
		public UnionGraph ( NamedGraphSetImpl ngs ) {
			super( ngs.graphs );
			this.ngs = ngs;
		}
	}

}
